/*
 * htons.h
 *
 *  Created on: Oct 8, 2010
 *      Author: Thomas Schmid
 */

#ifndef HTON_H_
#define HTON_H_

#include <inttypes.h>

extern uint32_t __REV16(uint16_t r);
extern uint32_t __REV(uint32_t r);

#define LITTLE_ENDIAN 1234
#define BIG_ENDIAN 4321

#define BYTE_ORDER LITTLE_ENDIAN

uint16_t htons(uint16_t x)
{
#if BYTE_ORDER == BIG_ENDIAN
  return x;
#elif BYTE_ORDER == LITTLE_ENDIAN
  return __REV16(x);
#else
# error "What kind of system is this?"
#endif
}

uint16_t ntohs(uint16_t x)
{
  return(htons(x));
}

uint32_t htonl(uint32_t x)
{
#if BYTE_ORDER == BIG_ENDIAN
  return x;
#elif BYTE_ORDER == LITTLE_ENDIAN
  return __REV(x);
#else
# error "What kind of system is this?"
#endif
}

uint32_t ntohl(uint32_t x)
{
  return(htons(x));
}


#endif /* HTON_H_ */
